<?php

require_once( 'class.focussitecall-credentials.php' );
require_once( 'class.focussitecall-sitecalls-model.php' );

require_once( 'class.focussitecall-templates-sitecalls-list-table.php' );
require_once( 'class.focussitecall-sitecalls-list-table.php' );

require_once( 'class.focussitecall-admin-post-controller.php' );

require_once( 'class.focussitecall-notices.php' );


class FocusSitecall_Admin_Settings_Page {
	private $credentials;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'page_init' ) );

		( new FocusSitecall_Admin_Post_Controller() )->register_actions();

		$this->credentials = new FocusSitecall_Credentials();
	}

	public function add_plugin_page() {
		add_menu_page(
			'Focus Sitecall Pro',
			'Focus Sitecall Pro',
			'manage_options',
			'sitecall-settings-admin',
			array( $this, 'create_admin_page' ),
            plugins_url() . '/' . dirname( plugin_basename( __FILE__ ) ) . '/images/sitecall_logo.svg'
        );
	}

	public function create_admin_page() {
		settings_errors();

		echo FocusSitecall_Notices::displayNotices( FocusSitecall_Notices::NOTICE_SUCCESS );
		echo FocusSitecall_Notices::displayNotices( FocusSitecall_Notices::NOTICE_ERROR );

		$this->credentials->create_admin_page();


        $connected = (bool)get_option( 'focussitecall_connected' );

        if ( $connected ) :

		$sitercalls_list_table = new Focussitecall_Sitecalls_List_Table();
		$sitercalls_list_table->prepare_items();

		$templates_sitercalls_list_table = new Focussitecall_Templates_Sitecalls_List_Table();
		$templates_sitercalls_list_table->prepare_items();

		?>


        <div class="wrap">
            <h2><?php _e('List of SiteCall widgets', 'focus-sitecall-pro'); ?></h2>

            <form action="admin-post.php" method="POST">
				<?php $sitercalls_list_table->display(); ?>

                <input type="hidden" name="action" value="refresh_sitecalls">
            </form>
        </div>


        <div class="wrap">
            <h2><?php _e('List of themes assigned to SiteCall widgets', 'focus-sitecall-pro'); ?></h2>

            <form action="admin-post.php" method="POST">
				<?php $templates_sitercalls_list_table->display(); ?>

                <input type="hidden" name="action" value="assign_sitecalls">
            </form>
        </div>


		<?php

        endif;

        $connected ?: include_once ('views/install_instructions/instruction.php');

	}

	public function page_init() {
		$this->credentials->page_init();
	}
}