<?php

class FocusSitecall_Fcc_Provider {
	const PUB_DISCOVERY_URL = 'https://pub-discovery.fcc-online.pl';

	const GET_SITECALL_PATH = '/getSitecallList';

	const FCC_DOMAIN = '.fcc-online.pl';

	public function discoverDomain( $domain ) {
		$returnedDomain = null;

		$result = $this->doRequest( self::PUB_DISCOVERY_URL . '?' . http_build_query( [ 'customer' => str_replace( self::FCC_DOMAIN, '', $domain ) ] ) );

		$resultDecoded = json_decode( $result, true );

		if ( ! isset( $resultDecoded['formsUrl'] ) ) {
			$success = false;
		} else {
			$success        = true;
			$returnedDomain = $resultDecoded['formsUrl'];
		}

		return [
			'success' => $success,
			'data'    => [
				'domain' => $returnedDomain
			]
		];
	}

	public function getSitecalls( $formsUrl, $token ) {
		$reuturnedSitecalls = null;

		$result        = $this->doRequest( trim( $formsUrl, '/' ) . self::GET_SITECALL_PATH, [ 'x-token: ' . $token ] );
		$resultDecoded = json_decode( $result, true );

		if ( isset( $result['success'] ) && $result['success'] ) {
			$success                = false;
			$reuturnedSitecallsData = null;
		} else {
			$success                = true;
			$reuturnedSitecallsData = $resultDecoded['data'];
		}

		return [
			'success' => $success,
			'data'    => $reuturnedSitecallsData
		];
	}

	private function doRequest( $url, array $headers = [] ) {
		$ch = curl_init();

		curl_setopt( $ch, CURLOPT_URL, $url );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );

		empty( $headers ) ?: curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );

		$result = curl_exec( $ch );
		curl_close( $ch );

		return $result;
	}
}