<?php
require_once( 'class.focussitecall-sitecalls-model.php' );
require_once( 'class.focussitecall-templates-sitecalls-model.php' );


if ( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

class Focussitecall_Sitecalls_List_Table extends WP_List_Table {

	public function __construct( $args = array() ) {
		parent::__construct( $args );
	}

	public function prepare_items() {
		$columns  = $this->get_columns();
		$hidden   = $this->get_hidden_columns();
		$sortable = $this->get_sortable_columns();
		$data     = $this->table_data();

		usort( $data, array( &$this, 'sort_data' ) );

		$perPage = 10;

		$currentPage = $this->get_pagenum();
		$totalItems  = count( $data );
		$this->set_pagination_args( array(
			'total_items' => $totalItems,
			'per_page'    => $perPage
		) );
		$data                  = array_slice( $data, ( ( $currentPage - 1 ) * $perPage ), $perPage );
		$this->_column_headers = array( $columns, $hidden, $sortable );
		$this->items           = $data;
	}

	public function get_columns() {
		$columns = array(
			'id'     => __('Id', 'focus-sitecall-pro'),
			'name'   => __('Name', 'focus-sitecall-pro'),
			'active' => __('Active', 'focus-sitecall-pro')
		);

		return $columns;
	}

	public function get_hidden_columns() {
		return array();
	}

	public function get_sortable_columns() {
		return array();
	}

	private function table_data() {
		return FocusSitecall_Sitecalls_Model::getAll();
	}

	public function column_default( $item, $column_name ) {
		switch ( $column_name ) {
			case 'id':
			case 'name':
				return $item[ $column_name ];
			case 'active':
				return $item[ $column_name ] ? __('yes', 'focus-sitecall-pro') : __('no', 'focus-sitecall-pro');
			default:
				return '';
		}
	}

	public function extra_tablenav( $which ) {
		if ( $which == "bottom" || $which == "top" ) {
			echo ' <input type="submit" name="submit" id="submit" class="button" value="' . __('Refresh list', 'focus-sitecall-pro') . '"> ';
		}
	}
}