<?php

require_once( 'class.focussitecall-model.php' );

class FocusSitecall_Sitecalls_Model extends FocusSitecall_Model {
	const SITECALL_SITECALLS_OPTION_KEY = 'focussitecall_sitecalls';
	const NO_WIDGETS_DEFINED = "-1";
	const CODE = 'paste';
	const NAME = 'name';

	public static function getAll() {
		return self::getAllByKey( self::SITECALL_SITECALLS_OPTION_KEY );
	}

	public static function setAll( $data ) {
		self::setAllByKey( $data, self::SITECALL_SITECALLS_OPTION_KEY );
	}

	public static function getCodeById( $widgetId ) {
		return self::processGetValue( $widgetId, self::CODE );
	}

	public static function getWidgetById( $widgetId ) {
		return self::processGetValue( $widgetId );
	}

	public static function getDropdown( $selectId, array $firstOptionData = [], $defaultSelected = null ) {
		$sitecalls = self::getAll();

		$output = '';
		$output .= sprintf( '<select name="%s">', $selectId );
		if ( $sitecalls ) {
			if ( ! empty( $firstOptionData ) ) {
				$output .= sprintf( '<option value="%s">%s</option>', $firstOptionData['value'], $firstOptionData['name'] );
			}

			foreach ( $sitecalls as $sitecall ) {
				$output .= sprintf( '<option %s value="%s">%s</option>',
					$defaultSelected == $sitecall['id'] ? 'selected="selected"' : '',
					$sitecall['id'],
					$sitecall['name'] );
			}
			$output .= '</select>';
		} else {
			$output .= sprintf( '<option value="%s" selected="selected">%s</option>', self::NO_WIDGETS_DEFINED, __('No defined widgets', 'focus-sitecall-pro') );
		}

		return $output;
	}

	private static function processGetValue( $widgetId, $key = null ) {
		$widgets = self::getAll();

		$result = [];
		foreach ( $widgets as $widget ) {
			if ( $widget['id'] === $widgetId ) {
				if ( is_null( $key ) ) {
					$result = $widget;
				} else {
					$result = $widget[ $key ];
				}
				break;
			}
		}

		return $result;
	}
}
